#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include "string.h"
#include <signal.h>
#include <pthread.h>
#include <sys/shm.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <sys/wait.h>
#include "pct.h"

int sem_id;
int shm_id;
int pct_shm_id;


void signal_semaphore(int sem_id){
        struct sembuf sops = {0, 1, 0};
        if(semop(sem_id, &sops, 1) == -1){
        perror("semop error in child");
        exit(EXIT_FAILURE);
        }
}

void wait_semaphore(int sem_id){
        struct sembuf sops = {0, -1, 0};
        semop(sem_id, &sops, 1);
}

int main (int argc, char *argv[]){

        srand(time(NULL));

        char* shmfile = "child.c";
        char* pctfile = "readme";

        key_t clockKey = ftok(shmfile, 65); //Shared memory for the clock
        shm_id = shmget(clockKey, sizeof(struct Clock), 0666);
        if(shm_id < 0){
                perror("shmget");
                exit(1);
        }

        system_clock = (struct Clock *)shmat(shm_id, NULL, 0);
        if(system_clock == (void *) -1){
                perror("shmat");
                return 1;
        }

        union semun{
                int val;
                struct semid_ds *buf;
                unsigned short *array;
                struct seminfo *__buf;
        }argument;

        argument.val = 1;
          key_t pctKey = ftok(pctfile, 65);
        pct_shm_id = shmget(pctKey, sizeof(process_control_table) * maxProcessStructures, 0666);
        if(pct_shm_id < 0){
                perror("shmgetPCT");
        }

        PCB = (process_control_table *)shmat(pct_shm_id, NULL, 0);
        if(PCB == (void *) -1){
                perror("shmatPCT");
                return 1;
        }

        char* semfile = "oss.c";
        key_t semkey = ftok(semfile, 65);
        //sem_id = semget(semkey, 1, 066);
        sem_id = semget(semkey, 1, 0);
        if(sem_id == -1){
                perror("semaphore creation failed");
                exit(EXIT_FAILURE);
        }

        //semctl(sem_id, 0, 1);




        //if(PCB->CPU_time > 0){
        int work_time = (rand() % 5) + 1;
        printf("Child process is doing some work\n");
        sleep(work_time);
        //PCB->pid;
        //PCB->totalTime += 2;
        printf("Child process has finished its work and it took %d\n", work_time);

        signal_semaphore(sem_id);

        printf("sending message to parent\n");
        if(shmdt(system_clock) == -1){ //Deallocates shared memory
                perror("Error: shmdtclock");
                exit(EXIT_FAILURE);
        }

        if(shmdt(PCB) == -1){ //Deallocates shared memory
                perror("Error: shmdtPCB");
                exit(EXIT_FAILURE);
        }

        /*if(semctl(sem_id, 0, IPC_RMID, 0) == -1){
                perror("semctl");
                exit(EXIT_FAILURE);

        }*/


        return 0;
}
        


